package com.rebusland.fin.derivatives.eq.server.input.model;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class Underlying extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notEmpty")
	private final String alias;

	// TODO choose one among the two: perhaps it's better to have just a single field "price"
	@PropertyDefinition(validate = "notNull")
	private final Double spotPrice;

	// TODO choose one among the two: perhaps it's better to have just a single field "price"
	@PropertyDefinition(validate = "notNull")
	private final Double refPrice;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code Underlying}.
	 * @return the meta-bean, not null
	 */
	public static Underlying.Meta meta() {
		return Underlying.Meta.INSTANCE;
	}

	static {
		MetaBean.register(Underlying.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static Underlying.Builder builder() {
		return new Underlying.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected Underlying(Underlying.Builder builder) {
		JodaBeanUtils.notEmpty(builder.alias, "alias");
		JodaBeanUtils.notNull(builder.spotPrice, "spotPrice");
		JodaBeanUtils.notNull(builder.refPrice, "refPrice");
		this.alias = builder.alias;
		this.spotPrice = builder.spotPrice;
		this.refPrice = builder.refPrice;
	}

	@Override
	public Underlying.Meta metaBean() {
		return Underlying.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the alias.
	 * @return the value of the property, not empty
	 */
	public String getAlias() {
		return alias;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the spotPrice.
	 * @return the value of the property, not null
	 */
	public Double getSpotPrice() {
		return spotPrice;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the refPrice.
	 * @return the value of the property, not null
	 */
	public Double getRefPrice() {
		return refPrice;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			Underlying other = (Underlying) obj;
			return JodaBeanUtils.equal(alias, other.alias) &&
					JodaBeanUtils.equal(spotPrice, other.spotPrice) &&
					JodaBeanUtils.equal(refPrice, other.refPrice);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(alias);
		hash = hash * 31 + JodaBeanUtils.hashCode(spotPrice);
		hash = hash * 31 + JodaBeanUtils.hashCode(refPrice);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(128);
		buf.append("Underlying{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("alias").append('=').append(JodaBeanUtils.toString(alias)).append(',').append(' ');
		buf.append("spotPrice").append('=').append(JodaBeanUtils.toString(spotPrice)).append(',').append(' ');
		buf.append("refPrice").append('=').append(JodaBeanUtils.toString(refPrice)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code Underlying}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code alias} property.
		 */
		private final MetaProperty<String> alias = DirectMetaProperty.ofImmutable(
				this, "alias", Underlying.class, String.class);
		/**
		 * The meta-property for the {@code spotPrice} property.
		 */
		private final MetaProperty<Double> spotPrice = DirectMetaProperty.ofImmutable(
				this, "spotPrice", Underlying.class, Double.class);
		/**
		 * The meta-property for the {@code refPrice} property.
		 */
		private final MetaProperty<Double> refPrice = DirectMetaProperty.ofImmutable(
				this, "refPrice", Underlying.class, Double.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"alias",
				"spotPrice",
				"refPrice");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case 92902992:  // alias
					return alias;
				case -945546905:  // spotPrice
					return spotPrice;
				case -741970826:  // refPrice
					return refPrice;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public Underlying.Builder builder() {
			return new Underlying.Builder();
		}

		@Override
		public Class<? extends Underlying> beanType() {
			return Underlying.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code alias} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<String> alias() {
			return alias;
		}

		/**
		 * The meta-property for the {@code spotPrice} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Double> spotPrice() {
			return spotPrice;
		}

		/**
		 * The meta-property for the {@code refPrice} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Double> refPrice() {
			return refPrice;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case 92902992:  // alias
					return ((Underlying) bean).getAlias();
				case -945546905:  // spotPrice
					return ((Underlying) bean).getSpotPrice();
				case -741970826:  // refPrice
					return ((Underlying) bean).getRefPrice();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code Underlying}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<Underlying> {

		private String alias;
		private Double spotPrice;
		private Double refPrice;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(Underlying beanToCopy) {
			this.alias = beanToCopy.getAlias();
			this.spotPrice = beanToCopy.getSpotPrice();
			this.refPrice = beanToCopy.getRefPrice();
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case 92902992:  // alias
					return alias;
				case -945546905:  // spotPrice
					return spotPrice;
				case -741970826:  // refPrice
					return refPrice;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case 92902992:  // alias
					this.alias = (String) newValue;
					break;
				case -945546905:  // spotPrice
					this.spotPrice = (Double) newValue;
					break;
				case -741970826:  // refPrice
					this.refPrice = (Double) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public Underlying build() {
			return new Underlying(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the alias.
		 * @param alias  the new value, not empty
		 * @return this, for chaining, not null
		 */
		public Builder alias(String alias) {
			JodaBeanUtils.notEmpty(alias, "alias");
			this.alias = alias;
			return this;
		}

		/**
		 * Sets the spotPrice.
		 * @param spotPrice  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder spotPrice(Double spotPrice) {
			JodaBeanUtils.notNull(spotPrice, "spotPrice");
			this.spotPrice = spotPrice;
			return this;
		}

		/**
		 * Sets the refPrice.
		 * @param refPrice  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder refPrice(Double refPrice) {
			JodaBeanUtils.notNull(refPrice, "refPrice");
			this.refPrice = refPrice;
			return this;
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(128);
			buf.append("Underlying.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("alias").append('=').append(JodaBeanUtils.toString(alias)).append(',').append(' ');
			buf.append("spotPrice").append('=').append(JodaBeanUtils.toString(spotPrice)).append(',').append(' ');
			buf.append("refPrice").append('=').append(JodaBeanUtils.toString(refPrice)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
